///###////////////////////////////////////////////////////////////////////////
//
// Burton Computer Corporation
// http://www.burton-computer.com
// http://www.cooldevtools.com
// $Id: FrequencyDBImpl.h,v 1.1 2002/09/10 21:08:22 bburton Exp $
//
// Copyright (C) 2000 Burton Computer Corporation
// ALL RIGHTS RESERVED
//
// This program is open source software; you can redistribute it
// and/or modify it under the terms of the Q Public License (QPL)
// version 1.0. Use of this software in whole or in part, including
// linking it (modified or unmodified) into other programs is
// subject to the terms of the QPL.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// Q Public License for more details.
//
// You should have received a copy of the Q Public License
// along with this program; see the file LICENSE.txt.  If not, visit
// the Burton Computer Corporation or CoolDevTools web site
// QPL pages at:
//
//    http://www.burton-computer.com/qpl.html
//    http://www.cooldevtools.com/qpl.html
//

#ifndef _FrequencyDBImpl_h
#define _FrequencyDBImpl_h

#include "FrequencyDB.h"

class FrequencyDBImpl
{
public:
  virtual ~FrequencyDBImpl()
  {
  }

  virtual bool open(const string &filename) = 0;
  virtual void close() = 0;

  virtual void flush() = 0;

  virtual void writeWord(const string &word,
                         const FrequencyDB::WordData &word_data) = 0;

  virtual bool readWord(const string &word,
                        FrequencyDB::WordData &word_data) = 0;

  virtual bool firstWord(string &word,
                         FrequencyDB::WordData &counts) = 0;

  virtual bool nextWord(string &word,
                        FrequencyDB::WordData &counts) = 0;

  virtual string getDatabaseType() const = 0;
};

#endif // _FrequencyDBImpl_h
