///###////////////////////////////////////////////////////////////////////////
//
// Burton Computer Corporation
// http://www.burton-computer.com
// http://www.cooldevtools.com
// $Id: FrequencyDBImpl_bdb.h,v 1.2 2002/09/10 21:08:22 bburton Exp $
//
// Copyright (C) 2000 Burton Computer Corporation
// ALL RIGHTS RESERVED
//
// This program is open source software; you can redistribute it
// and/or modify it under the terms of the Q Public License (QPL)
// version 1.0. Use of this software in whole or in part, including
// linking it (modified or unmodified) into other programs is
// subject to the terms of the QPL.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// Q Public License for more details.
//
// You should have received a copy of the Q Public License
// along with this program; see the file LICENSE.txt.  If not, visit
// the Burton Computer Corporation or CoolDevTools web site
// QPL pages at:
//
//    http://www.burton-computer.com/qpl.html
//    http://www.cooldevtools.com/qpl.html
//

#ifndef _FrequencyDBImpl_bdb_h
#define _FrequencyDBImpl_bdb_h

#ifndef USE_DBM

#include <db.h>

#include "Message.h"
#include "FrequencyDBImpl.h"

class FrequencyDBImpl_bdb : public FrequencyDBImpl
{
public:
  FrequencyDBImpl_bdb();
  ~FrequencyDBImpl_bdb();

  bool open(const string &filename);
  void close();

  void flush();

  void writeWord(const string &word,
                 const FrequencyDB::WordData &word_data);

  bool readWord(const string &word,
                FrequencyDB::WordData &word_data);

  bool firstWord(string &word,
                 FrequencyDB::WordData &counts);

  bool nextWord(string &word,
                FrequencyDB::WordData &counts);

  string getDatabaseType() const;

private:
  bool loadKey(DBT &key,
               string &word,
               FrequencyDB::WordData &counts) const;

  bool loadKey(DBT &key,
               FrequencyDB::WordData &counts) const;

  void closeCursor();

private:
  /// Not implemented.
  FrequencyDBImpl_bdb(const FrequencyDBImpl_bdb &);

  /// Not implemented.
  FrequencyDBImpl_bdb& operator=(const FrequencyDBImpl_bdb &);

private:
  DB *m_file;
  DBC *m_cursor;
};

#endif // USE_DBM

#endif // _FrequencyDBImpl_bdb_h
