#!/bin/bash
# Script to run spamprobe on input files generated by splitmail.rb and
# summarize the results.

DBDIR=$HOME/sptest

VERBOSE=""
SPEXEC="./spamprobe"

(
for i in normal graham ; do
  echo RUNNING TEST $i
  echo Building database
  if [ -d $DBDIR ] ; then
    \rm $DBDIR/sp_words* $DBDIR/*.pag $DBDIR/*.dir 2>/dev/null
  fi
  $SPEXEC -t $i -cd $DBDIR spam _spam.1
  $SPEXEC -t $i -cd $DBDIR good _good.1

  echo Verifying good emails
  $SPEXEC $VERBOSE -t $i -cd $DBDIR score _good.1 | ruby countscores.rb
  $SPEXEC $VERBOSE -t $i -cd $DBDIR -T find-spam _good.1

  echo Verifying spam emails
  $SPEXEC $VERBOSE -t $i -cd $DBDIR score _spam.1 | ruby countscores.rb

  echo Scoring good mails
  $SPEXEC $VERBOSE -t $i -cd $DBDIR score _good.2 | ruby countscores.rb
  $SPEXEC $VERBOSE -t $i -cd $DBDIR -T find-spam _good.2

  echo Scoring spam mails
  $SPEXEC $VERBOSE -t $i -cd $DBDIR score _spam.2 | ruby countscores.rb

  #echo Incrementally scoring good mails
  #ruby incrtest.rb _good.2 good "$SPEXEC -t $i -cd $DBDIR"

  #echo Incrementally scoring spam mails
  #ruby incrtest.rb _spam.2 spam "$SPEXEC -t $i -cd $DBDIR"

  echo
done
) 2>&1 | tee _results
