#!/usr/bin/ruby
#
# A script to split a mbox file into two files with a randomly
# chosen set of emails in each file.  Used to create test cases
# for trying out different sets of filter parameters.
#

if ARGV.length < 2
  STDERR.printf("usage: splitmail percentage outfileprefix [filename...]\n")
  exit 1
end

pct = ARGV.shift.to_i
prefix = ARGV.shift
files = [ File.open(prefix + ".1", "w"), File.open(prefix + ".2", "w") ];
first = [ true, true ]
filenum = 0
ARGV.each do |filename|
  on_blank = true
  File.open(filename).each do |line|
    if on_blank and line =~ /^From\s+\S+\s+\w\w\w\s+\w\w\w\s+\d\d?\s+\d\d\s*:\s*\d\d\s*:\s*\d\d\s+\d\d\d\d/
      on_blank = false
      filenum = (rand(100) <= pct) ? 0 : 1
      if first[filenum]
        first[filenum] = false
      else
        files[filenum].print("\n")
      end
    elsif line.length == 1
      on_blank = true
    end
    files[filenum].print(line)
  end
end
