///###////////////////////////////////////////////////////////////////////////
//
// Burton Computer Corporation
// http://www.burton-computer.com
// http://www.cooldevtools.com
// $Id: test_reader.cc,v 1.2 2002/09/15 12:45:31 bburton Exp $
//
// Copyright (C) 2000 Burton Computer Corporation
// ALL RIGHTS RESERVED
//
// This program is open source software; you can redistribute it
// and/or modify it under the terms of the Q Public License (QPL)
// version 1.0. Use of this software in whole or in part, including
// linking it (modified or unmodified) into other programs is
// subject to the terms of the QPL.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// Q Public License for more details.
//
// You should have received a copy of the Q Public License
// along with this program; see the file LICENSE.txt.  If not, visit
// the Burton Computer Corporation or CoolDevTools web site
// QPL pages at:
//
//    http://www.burton-computer.com/qpl.html
//    http://www.cooldevtools.com/qpl.html
//

#include "MimeMessageReader.h"

static void print_header(MimeMessageReader &in,
                         const string &name)
{
  vector<string> text;
  if (in.getHeader(name, text)) {
    for (vector<string>::const_iterator i = text.begin(); i != text.end(); ++i) {
      cout << name << ": " << *i << endl;
    }
  }
}

static void print_charset(MimeMessageReader &in)
{
  string value;
  if (in.getCharSet(value)) {
    cout << "CharSet: " << value << endl;
  }
}

int main(int argc,
         char **argv)
{
  MimeMessageReader in(cin, true, false);
  while (in.readNextHeader()) {
    cout << "*** NEW MESSAGE ***" << endl;
    print_header(in, "Received");
    print_header(in, "Message-Id");
    print_header(in, "From");
    print_header(in, "To");
    print_header(in, "Cc");
    print_header(in, "Bcc");
    print_header(in, "Subject");
    print_charset(in);
    cout << "*** BODY TEXT OF MESSAGE ***" << endl;
    string content_type, text;
    while (in.readText(text, content_type)) {
      if (content_type.length() > 0) {
        cout << "Content-Type: " << content_type << endl;
      }
      cout << text << endl;
    }
    cout << "*** END OF MESSAGE ***" << endl;
  }
  return 0;
}
