///###////////////////////////////////////////////////////////////////////////
//
// Burton Computer Corporation
// http://www.burton-computer.com
// http://www.cooldevtools.com
// $Id: util.cc,v 1.4 2002/09/12 18:33:08 bburton Exp $
//
// Copyright (C) 2000 Burton Computer Corporation
// ALL RIGHTS RESERVED
//
// This program is open source software; you can redistribute it
// and/or modify it under the terms of the Q Public License (QPL)
// version 1.0. Use of this software in whole or in part, including
// linking it (modified or unmodified) into other programs is
// subject to the terms of the QPL.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// Q Public License for more details.
//
// You should have received a copy of the Q Public License
// along with this program; see the file LICENSE.txt.  If not, visit
// the Burton Computer Corporation or CoolDevTools web site
// QPL pages at:
//
//    http://www.burton-computer.com/qpl.html
//    http://www.cooldevtools.com/qpl.html
//

#include "util.h"

const string EMPTY_STRING;

bool is_debug = false;

string trim_copy(const string &str,
                 string::size_type offset)
{
  string answer;
  const char *s = str.c_str() + offset;
  while (*s && is_space(*s)) {
    ++s;
  }
  while (*s) {
    answer += *s;
    ++s;
  }
  return answer;
}

string trim(const string &str)
{
  const char *start = str.c_str();
  while (*start && is_space(*start)) {
    ++start;
  }

  string answer;
  if (*start) {
    const char *last = start;
    for (const char *s = start; *s; ++s) {
      if (!is_space(*s)) {
        last = s;
      }
    }
    answer.assign(start, last - start + 1);
  }

  return answer;
}

string to_lower(const string &str)
{
  string answer;
  for (const char *s = str.c_str(); *s; ++s) {
    answer += to_lower(*s);
  }
  return answer;
}

bool is_digits(const string &str)
{
  for (const char *s = str.c_str(); *s; ++s) {
    if (!is_digit(*s)) {
      return false;
    }
  }
  return true;
}

bool is_lower(const string &str)
{
  for (const char *s = str.c_str(); *s; ++s) {
    if (is_alpha(*s) && !is_lower(*s)) {
      return false;
    }
  }
  return true;
}
