///###////////////////////////////////////////////////////////////////////////
//
// Burton Computer Corporation
// http://www.burton-computer.com
// http://www.cooldevtools.com
// $Id: util.h,v 1.10 2002/09/19 16:15:39 bburton Exp $
//
// Copyright (C) 2000 Burton Computer Corporation
// ALL RIGHTS RESERVED
//
// This program is open source software; you can redistribute it
// and/or modify it under the terms of the Q Public License (QPL)
// version 1.0. Use of this software in whole or in part, including
// linking it (modified or unmodified) into other programs is
// subject to the terms of the QPL.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// Q Public License for more details.
//
// You should have received a copy of the Q Public License
// along with this program; see the file LICENSE.txt.  If not, visit
// the Burton Computer Corporation or CoolDevTools web site
// QPL pages at:
//
//    http://www.burton-computer.com/qpl.html
//    http://www.cooldevtools.com/qpl.html
//

#ifndef _util_h
#define _util_h

#include <memory>
#include <string>
#include <cctype>
#include <cassert>
#include <iostream>
#include "NewPtr.h"

using namespace std;

extern bool is_debug;

extern string to_lower(const string &str);

extern bool is_lower(const string &str);

extern string trim_copy(const string &str,
                        string::size_type start_offset);

extern string trim(const string &str);

inline bool starts_with(const string &str,
                        const char *prefix)
{
  return strncmp(str.c_str(), prefix, strlen(prefix)) == 0;
}

inline bool starts_with(const string &str,
                        const string &prefix)
{
  return strncmp(str.c_str(), prefix.c_str(), prefix.length()) == 0;
}

extern bool is_digits(const string &str);

// work around for unsafe ctype functions on solaris
inline bool is_lower(char ch)
{
  return islower((unsigned)ch);
}

inline bool is_space(char ch)
{
  return isspace((unsigned)ch);
}

inline bool is_alpha(char ch)
{
  return isalpha((unsigned)ch);
}

inline bool is_alnum(char ch)
{
  return isalnum((unsigned)ch);
}

inline bool is_digit(char ch)
{
  return isdigit((unsigned)ch);
}

inline char to_lower(char ch)
{
  return tolower((unsigned)ch);
}

inline bool is_cntrl(char ch)
{
  return iscntrl((unsigned)ch);
}

inline bool is_xdigit(char ch)
{
  return isxdigit((unsigned)ch);
}

extern const string EMPTY_STRING;

#endif // _util_h
