#!/bin/bash
# Script to run spamprobe on input files generated by splitmail.rb and
# summarize the results.

DBDIR=$HOME/sptest

SPEXEC=./spamprobe

(
for h in normal nox all ; do
  echo BUILDING DATABASES FOR TEST WITH $h HEADERS
  if [ -d $DBDIR ] ; then
    \rm $DBDIR/*.pag $DBDIR/*.dir $DBDIR/*.db $DBDIR/sp_words 2>/dev/null
  fi
  cmd="$SPEXEC -H $h -cd $DBDIR"
  $cmd spam _spam.1
  $cmd good _good.1

  for w in 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30; do
    for r in 1 2 3 ; do
      echo RUNNING TEST with $h headers $w words $r repeats
      cmd="$SPEXEC -H $h -r $r -w $w -cd $DBDIR"

      echo Verifying good emails
      $cmd score _good.1 | ruby countscores.rb
      #$cmd find-spam _good.1

      echo Verifying spam emails
      $cmd score _spam.1 | ruby countscores.rb
      #$cmd find-good _spam.1

      echo Scoring good mails
      $cmd score _good.2 | ruby countscores.rb
      #$cmd find-spam _good.2

      echo Scoring spam mails
      $cmd score _spam.2 | ruby countscores.rb
      #$cmd find-good _spam.2

      #echo Incrementally scoring good mails
      #ruby incrtest.rb _good.2 good "$cmd"

      #echo Incrementally scoring spam mails
      #ruby incrtest.rb _spam.2 spam "$cmd"

      echo
    done
  done
done
) 2>&1 | tee _results
